class Pair(object):

    def __init__(self, first, rest=None):
        self.first = first
        self.rest = rest

    def __repr__(self):
        return 'Pair({}, {})'.format(repr(self.first), repr(self.rest))


class nil(object):

    def __repr__(self):
        return 'nil'

nil = nil()

def len_rlist(rlist):
    if rlist is nil:
        return 0
    return 1 + len_rlist(rlist.rest)

def map_rlist(fn, rlist):
    if rlist is nil:
        return nil
    return Pair(fn(rlist.first), map_rlist(fn, rlist.rest))

def reduce_rlist(fn, base, rlist):
    if rlist is nil:
        return base
    return fn(rlist.first, reduce_rlist(fn, base, rlist.rest))
